/**
 * jQuery Video Embedder
 * by Zawntech
 */
(function($)
{
    class urlParser
    {
        static youtube(input)
        {
            let ID = '', url;
            url = input.replace(/(>|<)/gi,'').split(/(vi\/|v=|\/v\/|youtu\.be\/|\/embed\/)/);
            if(url[2] !== undefined) {
                ID = url[2].split(/[^0-9a-z_\-]/i);
                ID = ID[0];
            }
            else {
                ID = url;
            }
            return ID;
        }
    }

    class embedder
    {
        static youtube(id) {
            return `<div class="embed-container"><iframe src="http://www.youtube.com/embed/${id}" frameborder="0" allowfullscreen></iframe></div>`;
        }
    }

    class jQueryVideoEmbedder
    {
        public static printCss() {
        }
        public static determineNetwork(input)
        {
            if ( '' !== urlParser.youtube(input) ) {
                return 'youtube';
            }
            return false;
        }

        public defaults = {
        };

        public constructor(options)
        {
            let settings: any = $.extend( this.defaults, options ),
                url = $(this).data().videoUrl,
                network = jQueryVideoEmbedder.determineNetwork(url),
                code = urlParser[network](url);

            this.html( embedder[network](code) );

            return this;
        }
    }

    /** Bind the plugin. */
    $.fn.videoEmbedder = jQueryVideoEmbedder;

    // Loop through all div elements.
    $(document).ready(() => {

        $('head').append(`<style>.embed-container { position: relative; padding-bottom: 56.25%; height: 0; overflow: hidden; max-width: 100%; } .embed-container iframe, .embed-container object, .embed-container embed { position: absolute; top: 0; left: 0; width: 100%; height: 100%; }</style>`);

        $('div').each((i, el) => {
            // Does this element have a video-url binding?
            if ( 'undefined' !== typeof( $(el).data().videoUrl ) )
            {
                $(el).videoEmbedder();
            }
        });
    });
})(jQuery);